
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import static java.util.concurrent.Executors.newFixedThreadPool;
import java.util.concurrent.Future;

public class ThreadPoolExample {

    public static void main(String[] args) {

        ThreadPoolExample tP = new ThreadPoolExample();
        tP.test(2);

    }

    ExecutorService threadPool;

    public void test(int numberOfThreads) {

        threadPool = newFixedThreadPool(numberOfThreads);
        List<Future> futures = new ArrayList<>();

        for (int i = 1; i <= 10; i++) {
            Callable<String> aCallable = new CallableImpl(i);
            Future<String> submit = threadPool.submit(aCallable);
            futures.add(submit);
        }

        try {
            for (Future future : futures) {
                System.out.println(future.get());
            }
        } catch (Exception ex) {
            System.out.println("Not ready ?? ...");
        }

        threadPool.shutdown(); // shutdown the pool.

    }

    private class CallableImpl implements Callable<String> {

        String name;

        public CallableImpl(int number) {
            name = "Callable " + number;
        }

        @Override
        public String call() {
            for (int i = 0; i < 5; i++) {
                System.out.println(name + " is doing something");
                try {
                    Thread.sleep(200); // make it sleep a little
                } catch (InterruptedException ex) {
                    System.out.println("Not sleeping ?? ...");
                }
            }
            return name + " is done !";
        }
    }
}
